---
product: "AG Grid"
title: "Aggregation - Configure Columns"
description: "Columns can be configured to aggregate data for each level of row grouping or tree data."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation-custom-functions/"
    - title: "Total Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation-total-rows/"
    - title: "Filtering "
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation-filtering/"
    - title: "Show Values As"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation-show-values-as/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Aggregation - Configure Columns

Columns can be configured to aggregate data for each level of row grouping or tree data.

#### Enabling Aggregation

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "total", aggFunc: "sum" },
    { field: "total", aggFunc: "avg" },
    { field: "total", aggFunc: "count" },
    { field: "total", aggFunc: "min" },
    { field: "total", aggFunc: "max" },
    { field: "total", aggFunc: "first" },
    { field: "total", aggFunc: "last" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 140,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Enabling Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/enable-aggregation/typescript/)

## Enabling Aggregation

An aggregation function can be applied to a column by setting the `aggFunc` grid option to one of: `"sum"`, `"min"`, `"max"`, `"first"`, `"last"`, `"count"`, or `"avg"`.

The example above demonstrates the following configuration:

```js
const gridOptions = {
    columnDefs: [
        { field: 'total', aggFunc: 'sum' },
        { field: 'total', aggFunc: 'avg' },
        { field: 'total', aggFunc: 'count' },
        { field: 'total', aggFunc: 'min' },
        { field: 'total', aggFunc: 'max' },
        { field: 'total', aggFunc: 'first' },
        { field: 'total', aggFunc: 'last' },
        // ... other column definitions
    ],

    // other grid options ...
}
```

> **Note**
>
> The built-in functions will support `bigint` values if you have them in your data, but the `avg` function will lose precision as it can only use integer arithmetic if `bigint` is used.

## Configuring via the UI

Enable users to configure aggregation functions on a column using the [Columns Tool Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-columns/) and [Column Menu](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-menu/) by setting the `enableValue` column definition property to `true`.

#### Directly Supplied Aggregation Functions

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", enableValue: true },
    { field: "silver", enableValue: true },
    { field: "gold", enableValue: true },
    { field: "total", enableValue: true },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 140,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: "columns",
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Directly Supplied Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured/typescript/)

The example above demonstrates the following configuration:

```js
const gridOptions = {
    columnDefs: [
        { field: 'bronze', enableValue: true },
        { field: 'silver', enableValue: true },
        { field: 'gold', enableValue: true },
        { field: 'total', enableValue: true },
        // ... other column definitions
    ],
    sideBar: 'columns',

    // other grid options ...
}
```

### Allowed Functions

To restrict the aggregation functions that can be applied to a column, set the `allowedAggFuncs` column definition property to an array of allowed aggregation function names. The functions appear in the order specified in the array.

#### Allowed Aggregations

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "First or Last",
      field: "total",
      aggFunc: "first",
      allowedAggFuncs: ["first", "last"],
      enableValue: true,
    },
    {
      headerName: "Min or Max",
      field: "total",
      aggFunc: "min",
      allowedAggFuncs: ["min", "max"],
      enableValue: true,
    },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: "columns",
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Allowed Aggregations](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-allowed-aggregations/typescript/)

The following configuration is an example demonstrating limiting a column to only allow the `"first"` and `"last"` aggregation functions:

```js
const gridOptions = {
    columnDefs: [
        { field: 'total', enableValue: true, allowedAggFuncs: ['first', 'last'] },
        // ... other column definitions
    ],

    // other grid options ...
}
```

### Default Function

When right clicked in the [Column Tool Panel](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-columns/) or dragged into the aggregation panel, the `"sum"` aggregation function is applied to the column. This default can be changed by setting the `defaultAggFunc` column definition property.

#### Default Aggregation

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    { field: "athlete", defaultAggFunc: "count", enableValue: true },
    { field: "year", defaultAggFunc: "count", enableValue: true },
    { field: "total", defaultAggFunc: "avg", enableValue: true },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: "columns",
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Default Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-default-aggregations/typescript/)

The example above demonstrates the following configuration:

```js
const gridOptions = {
    columnDefs: [
        { field: 'total', enableValue: true, defaultAggFunc: 'avg' },
        // ... other column definitions
    ],

    // other grid options ...
}
```

## Editing Aggregated Columns

Aggregated columns can be made editable at the group row level, allowing users to edit a group total and distribute the change to descendant rows. Set `groupRowEditable` on the column and configure a `groupRowValueSetter` to control how the edited value is distributed. The built-in distribution automatically handles all standard aggregation functions.

See [Editing Group Rows](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-edit/) for full details.

## Omit Function Name in Header

To omit the aggregation function name from the column header, set the `suppressAggFuncInHeader` grid option to `true`.

#### Suppress Aggregation Function in Header

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", aggFunc: "max" },
    { field: "silver", aggFunc: "max" },
    { field: "gold", aggFunc: "max" },
    { field: "total", aggFunc: "avg" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 140,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
};

function toggleProperty() {
  const suppressAggFuncInHeader = document.querySelector<HTMLInputElement>(
    "#suppressAggFuncInHeader",
  )!.checked;
  gridApi.setGridOption("suppressAggFuncInHeader", suppressAggFuncInHeader);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleProperty = toggleProperty;
}
```

[Live example: Suppress Aggregation Function in Header](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/suppress-func-name/typescript/)

The example above demonstrates the following configuration:

```js
const gridOptions = {
    suppressAggFuncInHeader: true,

    // other grid options ...
}
```


---
product: "AG Grid"
title: "Aggregation - Configure Columns"
description: "Columns can be configured to aggregate data for each level of row grouping or tree data."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation-custom-functions/"
    - title: "Total Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation-total-rows/"
    - title: "Filtering "
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation-filtering/"
    - title: "Show Values As"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation-show-values-as/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Aggregation - Configure Columns

Columns can be configured to aggregate data for each level of row grouping or tree data.

#### Enabling Aggregation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "total", aggFunc: "sum" },
    { field: "total", aggFunc: "avg" },
    { field: "total", aggFunc: "count" },
    { field: "total", aggFunc: "min" },
    { field: "total", aggFunc: "max" },
    { field: "total", aggFunc: "first" },
    { field: "total", aggFunc: "last" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 140,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Enabling Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/enable-aggregation/reactFunctionalTs/)

## Enabling Aggregation

An aggregation function can be applied to a column by setting the `aggFunc` grid option to one of: `"sum"`, `"min"`, `"max"`, `"first"`, `"last"`, `"count"`, or `"avg"`.

The example above demonstrates the following configuration:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'total', aggFunc: 'sum' },
    { field: 'total', aggFunc: 'avg' },
    { field: 'total', aggFunc: 'count' },
    { field: 'total', aggFunc: 'min' },
    { field: 'total', aggFunc: 'max' },
    { field: 'total', aggFunc: 'first' },
    { field: 'total', aggFunc: 'last' },
    // ... other column definitions
]);

<AgGridReact columnDefs={columnDefs} />
```

> **Note**
>
> The built-in functions will support `bigint` values if you have them in your data, but the `avg` function will lose precision as it can only use integer arithmetic if `bigint` is used.

## Configuring via the UI

Enable users to configure aggregation functions on a column using the [Columns Tool Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-columns/) and [Column Menu](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-menu/) by setting the `enableValue` column definition property to `true`.

#### Directly Supplied Aggregation Functions

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", enableValue: true },
    { field: "silver", enableValue: true },
    { field: "gold", enableValue: true },
    { field: "total", enableValue: true },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 140,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            sideBar={"columns"}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Directly Supplied Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured/reactFunctionalTs/)

The example above demonstrates the following configuration:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'bronze', enableValue: true },
    { field: 'silver', enableValue: true },
    { field: 'gold', enableValue: true },
    { field: 'total', enableValue: true },
    // ... other column definitions
]);
const sideBar = 'columns';

<AgGridReact
    columnDefs={columnDefs}
    sideBar={sideBar}
/>
```

### Allowed Functions

To restrict the aggregation functions that can be applied to a column, set the `allowedAggFuncs` column definition property to an array of allowed aggregation function names. The functions appear in the order specified in the array.

#### Allowed Aggregations

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "First or Last",
      field: "total",
      aggFunc: "first",
      allowedAggFuncs: ["first", "last"],
      enableValue: true,
    },
    {
      headerName: "Min or Max",
      field: "total",
      aggFunc: "min",
      allowedAggFuncs: ["min", "max"],
      enableValue: true,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            sideBar={"columns"}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Allowed Aggregations](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-allowed-aggregations/reactFunctionalTs/)

The following configuration is an example demonstrating limiting a column to only allow the `"first"` and `"last"` aggregation functions:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'total', enableValue: true, allowedAggFuncs: ['first', 'last'] },
    // ... other column definitions
]);

<AgGridReact columnDefs={columnDefs} />
```

### Default Function

When right clicked in the [Column Tool Panel](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-columns/) or dragged into the aggregation panel, the `"sum"` aggregation function is applied to the column. This default can be changed by setting the `defaultAggFunc` column definition property.

#### Default Aggregation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    { field: "athlete", defaultAggFunc: "count", enableValue: true },
    { field: "year", defaultAggFunc: "count", enableValue: true },
    { field: "total", defaultAggFunc: "avg", enableValue: true },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            autoGroupColumnDef={autoGroupColumnDef}
            sideBar={"columns"}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Default Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-default-aggregations/reactFunctionalTs/)

The example above demonstrates the following configuration:

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'total', enableValue: true, defaultAggFunc: 'avg' },
    // ... other column definitions
]);

<AgGridReact columnDefs={columnDefs} />
```

## Editing Aggregated Columns

Aggregated columns can be made editable at the group row level, allowing users to edit a group total and distribute the change to descendant rows. Set `groupRowEditable` on the column and configure a `groupRowValueSetter` to control how the edited value is distributed. The built-in distribution automatically handles all standard aggregation functions.

See [Editing Group Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-edit/) for full details.

## Omit Function Name in Header

To omit the aggregation function name from the column header, set the `suppressAggFuncInHeader` grid option to `true`.

#### Suppress Aggregation Function in Header

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", aggFunc: "max" },
    { field: "silver", aggFunc: "max" },
    { field: "gold", aggFunc: "max" },
    { field: "total", aggFunc: "avg" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 140,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const toggleProperty = useCallback(() => {
    const suppressAggFuncInHeader = document.querySelector<HTMLInputElement>(
      "#suppressAggFuncInHeader",
    )!.checked;
    gridRef.current!.api.setGridOption(
      "suppressAggFuncInHeader",
      suppressAggFuncInHeader,
    );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label>
              <span>suppressAggFuncInHeader:</span>
              <input
                id="suppressAggFuncInHeader"
                type="checkbox"
                onChange={toggleProperty}
              />
            </label>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Suppress Aggregation Function in Header](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/suppress-func-name/reactFunctionalTs/)

The example above demonstrates the following configuration:

```jsx
const suppressAggFuncInHeader = true;

<AgGridReact suppressAggFuncInHeader={suppressAggFuncInHeader} />
```


---
product: "AG Grid"
title: "Aggregation - Configure Columns"
description: "Columns can be configured to aggregate data for each level of row grouping or tree data."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation-custom-functions/"
    - title: "Total Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation-total-rows/"
    - title: "Filtering "
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation-filtering/"
    - title: "Show Values As"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation-show-values-as/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Aggregation - Configure Columns

Columns can be configured to aggregate data for each level of row grouping or tree data.

#### Enabling Aggregation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    { field: "year", rowGroup: true, hide: true },
    { field: "total", aggFunc: "sum" },
    { field: "total", aggFunc: "avg" },
    { field: "total", aggFunc: "count" },
    { field: "total", aggFunc: "min" },
    { field: "total", aggFunc: "max" },
    { field: "total", aggFunc: "first" },
    { field: "total", aggFunc: "last" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 140,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Enabling Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/enable-aggregation/angular/)

## Enabling Aggregation

An aggregation function can be applied to a column by setting the `aggFunc` grid option to one of: `"sum"`, `"min"`, `"max"`, `"first"`, `"last"`, `"count"`, or `"avg"`.

The example above demonstrates the following configuration:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'total', aggFunc: 'sum' },
    { field: 'total', aggFunc: 'avg' },
    { field: 'total', aggFunc: 'count' },
    { field: 'total', aggFunc: 'min' },
    { field: 'total', aggFunc: 'max' },
    { field: 'total', aggFunc: 'first' },
    { field: 'total', aggFunc: 'last' },
    // ... other column definitions
];
```

> **Note**
>
> The built-in functions will support `bigint` values if you have them in your data, but the `avg` function will lose precision as it can only use integer arithmetic if `bigint` is used.

## Configuring via the UI

Enable users to configure aggregation functions on a column using the [Columns Tool Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-columns/) and [Column Menu](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-menu/) by setting the `enableValue` column definition property to `true`.

#### Directly Supplied Aggregation Functions

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [sideBar]="sideBar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", enableValue: true },
    { field: "silver", enableValue: true },
    { field: "gold", enableValue: true },
    { field: "total", enableValue: true },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 140,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "columns";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Directly Supplied Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured/angular/)

The example above demonstrates the following configuration:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [sideBar]="sideBar"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'bronze', enableValue: true },
    { field: 'silver', enableValue: true },
    { field: 'gold', enableValue: true },
    { field: 'total', enableValue: true },
    // ... other column definitions
];
this.sideBar = 'columns';
```

### Allowed Functions

To restrict the aggregation functions that can be applied to a column, set the `allowedAggFuncs` column definition property to an array of allowed aggregation function names. The functions appear in the order specified in the array.

#### Allowed Aggregations

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [sideBar]="sideBar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    {
      headerName: "First or Last",
      field: "total",
      aggFunc: "first",
      allowedAggFuncs: ["first", "last"],
      enableValue: true,
    },
    {
      headerName: "Min or Max",
      field: "total",
      aggFunc: "min",
      allowedAggFuncs: ["min", "max"],
      enableValue: true,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "columns";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Allowed Aggregations](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-allowed-aggregations/angular/)

The following configuration is an example demonstrating limiting a column to only allow the `"first"` and `"last"` aggregation functions:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'total', enableValue: true, allowedAggFuncs: ['first', 'last'] },
    // ... other column definitions
];
```

### Default Function

When right clicked in the [Column Tool Panel](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-columns/) or dragged into the aggregation panel, the `"sum"` aggregation function is applied to the column. This default can be changed by setting the `defaultAggFunc` column definition property.

#### Default Aggregation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [sideBar]="sideBar"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    { field: "athlete", defaultAggFunc: "count", enableValue: true },
    { field: "year", defaultAggFunc: "count", enableValue: true },
    { field: "total", defaultAggFunc: "avg", enableValue: true },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "columns";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Default Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-default-aggregations/angular/)

The example above demonstrates the following configuration:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'total', enableValue: true, defaultAggFunc: 'avg' },
    // ... other column definitions
];
```

## Editing Aggregated Columns

Aggregated columns can be made editable at the group row level, allowing users to edit a group total and distribute the change to descendant rows. Set `groupRowEditable` on the column and configure a `groupRowValueSetter` to control how the edited value is distributed. The built-in distribution automatically handles all standard aggregation functions.

See [Editing Group Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-edit/) for full details.

## Omit Function Name in Header

To omit the aggregation function name from the column header, set the `suppressAggFuncInHeader` grid option to `true`.

#### Suppress Aggregation Function in Header

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label>
        <span>suppressAggFuncInHeader:</span>
        <input
          id="suppressAggFuncInHeader"
          type="checkbox"
          (change)="toggleProperty()"
        />
      </label>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "country", rowGroup: true, hide: true },
    { field: "bronze", aggFunc: "max" },
    { field: "silver", aggFunc: "max" },
    { field: "gold", aggFunc: "max" },
    { field: "total", aggFunc: "avg" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 140,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  toggleProperty() {
    const suppressAggFuncInHeader = document.querySelector<HTMLInputElement>(
      "#suppressAggFuncInHeader",
    )!.checked;
    this.gridApi.setGridOption(
      "suppressAggFuncInHeader",
      suppressAggFuncInHeader,
    );
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Suppress Aggregation Function in Header](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/suppress-func-name/angular/)

The example above demonstrates the following configuration:

```ts
<ag-grid-angular
    [suppressAggFuncInHeader]="suppressAggFuncInHeader"
    /* other grid options ... */ />

this.suppressAggFuncInHeader = true;
```


---
product: "AG Grid"
title: "Aggregation - Configure Columns"
description: "Columns can be configured to aggregate data for each level of row grouping or tree data."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation-custom-functions/"
    - title: "Total Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation-total-rows/"
    - title: "Filtering "
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation-filtering/"
    - title: "Show Values As"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation-show-values-as/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Aggregation - Configure Columns

Columns can be configured to aggregate data for each level of row grouping or tree data.

#### Enabling Aggregation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      { field: "year", rowGroup: true, hide: true },
      { field: "total", aggFunc: "sum" },
      { field: "total", aggFunc: "avg" },
      { field: "total", aggFunc: "count" },
      { field: "total", aggFunc: "min" },
      { field: "total", aggFunc: "max" },
      { field: "total", aggFunc: "first" },
      { field: "total", aggFunc: "last" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 140,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Enabling Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/enable-aggregation/vue3/)

## Enabling Aggregation

An aggregation function can be applied to a column by setting the `aggFunc` grid option to one of: `"sum"`, `"min"`, `"max"`, `"first"`, `"last"`, `"count"`, or `"avg"`.

The example above demonstrates the following configuration:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'total', aggFunc: 'sum' },
    { field: 'total', aggFunc: 'avg' },
    { field: 'total', aggFunc: 'count' },
    { field: 'total', aggFunc: 'min' },
    { field: 'total', aggFunc: 'max' },
    { field: 'total', aggFunc: 'first' },
    { field: 'total', aggFunc: 'last' },
    // ... other column definitions
];
```

> **Note**
>
> The built-in functions will support `bigint` values if you have them in your data, but the `avg` function will lose precision as it can only use integer arithmetic if `bigint` is used.

## Configuring via the UI

Enable users to configure aggregation functions on a column using the [Columns Tool Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-columns/) and [Column Menu](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-menu/) by setting the `enableValue` column definition property to `true`.

#### Directly Supplied Aggregation Functions

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :sideBar="sideBar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      { field: "bronze", enableValue: true },
      { field: "silver", enableValue: true },
      { field: "gold", enableValue: true },
      { field: "total", enableValue: true },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 140,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "columns",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Directly Supplied Aggregation Functions](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured/vue3/)

The example above demonstrates the following configuration:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :sideBar="sideBar"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'bronze', enableValue: true },
    { field: 'silver', enableValue: true },
    { field: 'gold', enableValue: true },
    { field: 'total', enableValue: true },
    // ... other column definitions
];
this.sideBar = 'columns';
```

### Allowed Functions

To restrict the aggregation functions that can be applied to a column, set the `allowedAggFuncs` column definition property to an array of allowed aggregation function names. The functions appear in the order specified in the array.

#### Allowed Aggregations

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :sideBar="sideBar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      {
        headerName: "First or Last",
        field: "total",
        aggFunc: "first",
        allowedAggFuncs: ["first", "last"],
        enableValue: true,
      },
      {
        headerName: "Min or Max",
        field: "total",
        aggFunc: "min",
        allowedAggFuncs: ["min", "max"],
        enableValue: true,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "columns",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Allowed Aggregations](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-allowed-aggregations/vue3/)

The following configuration is an example demonstrating limiting a column to only allow the `"first"` and `"last"` aggregation functions:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'total', enableValue: true, allowedAggFuncs: ['first', 'last'] },
    // ... other column definitions
];
```

### Default Function

When right clicked in the [Column Tool Panel](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-columns/) or dragged into the aggregation panel, the `"sum"` aggregation function is applied to the column. This default can be changed by setting the `defaultAggFunc` column definition property.

#### Default Aggregation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  ColumnsToolPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :autoGroupColumnDef="autoGroupColumnDef"
      :sideBar="sideBar"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      { field: "athlete", defaultAggFunc: "count", enableValue: true },
      { field: "year", defaultAggFunc: "count", enableValue: true },
      { field: "total", defaultAggFunc: "avg", enableValue: true },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "columns",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Default Aggregation](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/user-configured-default-aggregations/vue3/)

The example above demonstrates the following configuration:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'total', enableValue: true, defaultAggFunc: 'avg' },
    // ... other column definitions
];
```

## Editing Aggregated Columns

Aggregated columns can be made editable at the group row level, allowing users to edit a group total and distribute the change to descendant rows. Set `groupRowEditable` on the column and configure a `groupRowValueSetter` to control how the edited value is distributed. The built-in distribution automatically handles all standard aggregation functions.

See [Editing Group Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-edit/) for full details.

## Omit Function Name in Header

To omit the aggregation function name from the column header, set the `suppressAggFuncInHeader` grid option to `true`.

#### Suppress Aggregation Function in Header

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label>
          <span>suppressAggFuncInHeader:</span>
          <input id="suppressAggFuncInHeader" type="checkbox" v-on:change="toggleProperty()">
          </label>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :autoGroupColumnDef="autoGroupColumnDef"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "country", rowGroup: true, hide: true },
      { field: "bronze", aggFunc: "max" },
      { field: "silver", aggFunc: "max" },
      { field: "gold", aggFunc: "max" },
      { field: "total", aggFunc: "avg" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 140,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const rowData = ref<IOlympicData[]>(null);

    function toggleProperty() {
      const suppressAggFuncInHeader = document.querySelector<HTMLInputElement>(
        "#suppressAggFuncInHeader",
      )!.checked;
      gridApi.value.setGridOption(
        "suppressAggFuncInHeader",
        suppressAggFuncInHeader,
      );
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      rowData,
      onGridReady,
      toggleProperty,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Suppress Aggregation Function in Header](https://www.ag-grid.com/archive/36.2.0/examples/aggregation-columns/suppress-func-name/vue3/)

The example above demonstrates the following configuration:

```ts
<ag-grid-vue
    :suppressAggFuncInHeader="suppressAggFuncInHeader"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressAggFuncInHeader = true;
```
